import { ListSOP } from '../../libappsop/listsop';
import { FormSOP } from '../../libappsop/formsop';
import { DialogForecast } from '../dialogs/dialog.forecast';
import { DialogPostponeForecast } from '../dialogs/dialog.postponeforecast';

export class FormForecasts extends FormSOP {
  public listForecasts = new ListForecasts();
  public listForecastsPlanningLevel = new ListForecastsPlanningLevel();

  public constructor() {
    super('FormForecasts');
  }
}

export class ListForecasts extends ListSOP<DialogForecast, ListForecastsColumn> {
  public readonly title = 'Forecasts';

  public constructor() {
    super('ListSalesDemands', new DialogForecast());
  }
}

export class ListForecastsPlanningLevel extends ListSOP<DialogPostponeForecast, ListForecastsPlanningLevelColumn> {
  public readonly title = 'Forecasts at planning level';

  public constructor() {
    super('ListSDIP', new DialogPostponeForecast());
  }
}

// List Forecasts columns
export interface ListForecastsColumn {
  Product?: string;
  'Sales segment'?: string;
  'Stocking point'?: string;
  Start?: string;
  End?: string;
  'Original Qty'?: string;
  Price?: string;
}

export interface ListForecastsPlanningLevelColumn {
  Product?: string;
  'Sales segment'?: string;
  'Stocking point'?: string;
  Start?: string;
  End?: string;
  Quantity?: string;
}

// List Forecasts context menu items
const listForecastsContextMenuItem = {
  Create: { ContextMenu: 'listContextMenuSD', Name: 'MenuCreate', Label: 'Create' },
  Edit: { ContextMenu: 'listContextMenuSD', Name: 'MenuEdit', Label: 'Edit' },
  Delete: { ContextMenu: 'listContextMenuSD', Name: 'MenuDelete', Label: 'Delete' },
  AdjustQuantity: { ContextMenu: 'listContextMenuSD', Name: 'MenuAdjustQuantity', Label: 'Adjust Quantity...' },
};

const listForecastsPlanningLevelContextMenuItem = {
  Postpone: { ContextMenu: 'listContextMenuSDIP', Name: 'MenuPostpone', Label: 'Postpone' },
};

export { listForecastsContextMenuItem as ListForecastsContextMenuItem };
export { listForecastsPlanningLevelContextMenuItem as ListForecastsPlanningLevelContextMenuItem };
